# COM/USB-CDC Access Sample for AWG           Ver1.00

# 対象機種：AFG/MFGシリーズ
# 本サンプルはWindowsでのみ動作確認となります。
# WindowsがCOMポートとして認識するI/Fが利用できます。
# Linux系の場合はポート名がttyS,ttyUSB,ttyACMなどになります。
# USB-CDCの場合はボーレートは9600を指定します。
# USB-VCPの場合はボーレートは9600に合わせてください。
# PySerialモジュールを使用します。(pipなどで用意してください)
# GUI表示はTkinterを使用しています。
# 測定に必要な時間をインターバルに指定してください。

# coding:utf-8
import serial           # pyserialモジュール
import tkinter as tk    # tkモジュール
import tkinter.scrolledtext
import time

from time import sleep
from tkinter import ttk


instr = None
Baud =['115200', '9600']
loopFlg = 0

def Open_clicked():
    global instr

    btn1['state'] = tk.DISABLED
    btn2['state'] = tk.NORMAL
    btn3['state'] = tk.NORMAL
    btn4['state'] = tk.NORMAL
    btn5['state'] = tk.NORMAL
    btn6['state'] = tk.NORMAL
    btn7['state'] = tk.NORMAL
    btn8['state'] = tk.NORMAL
    btn9['state'] = tk.NORMAL
    txtRecive.delete('1.0',tk.END)

    try:
        instr = serial.Serial()
        instr.port = 'COM' + txtPort.get()        #Windows COMポート指定 Device Managerで確認
#        instr.port = 'ttyS'  + txtPort.get()     #Linux 標準COMポート　dmesgで確認
#        instr.port = 'ttyUSB'  + txtPort.get()   #Linux USB変換ポート　dmesgで確認
#        instr.port = 'ttyACM'  + txtPort.get()   #Linux USB変換ポート　dmesgで確認

        instr.baudrate =cbDevBaud.get()     # ボーレート指定
        instr.timeout = 0.5                 # タイムアウト指定

        instr.open()
        instr.write("*cls\n".encode("utf-8"))
        sleep(0.3)
        instr.write("*idn?\n".encode("utf-8"))
        sleep(0.3)
        txtRcv = instr.read(256)
        txtRecive.insert(tk.END,txtRcv.decode('ascii'))

    except:
        txtRecive.insert(tk.END,'Device Error')
        btn1['state'] = tk.NORMAL
        btn2['state'] = tk.DISABLED
        btn3['state'] = tk.NORMAL
        btn4['state'] = tk.DISABLED
        btn5['state'] = tk.DISABLED
        btn6['state'] = tk.DISABLED
        btn7['state'] = tk.DISABLED
        btn8['state'] = tk.DISABLED
        btn9['state'] = tk.DISABLED

def Close_clicked():
    global instr
    instr.write("OUTP1 off\n".encode("utf-8"))
    sleep(0.3)
    instr.write("syst:loc\n".encode("utf-8"))
    btn1['state'] = tk.NORMAL
    btn2['state'] = tk.DISABLED
    btn3['state'] = tk.NORMAL
    btn4['state'] = tk.DISABLED
    btn5['state'] = tk.DISABLED
    btn6['state'] = tk.DISABLED
    btn7['state'] = tk.DISABLED
    btn8['state'] = tk.DISABLED
    btn9['state'] = tk.DISABLED
    instr.close()


def Exit_clicked():

    root.destroy()

def SINE_clicked():
    global instr
    txtSend = 'SOUR1:FUNC SIN\n'
    instr.write(txtSend.encode("utf-8"))


def SQU_clicked():
    global instr
    txtSend = 'SOUR1:FUNC SQU\n'
    instr.write(txtSend.encode("utf-8"))

def AMPL_clicked():
    global instr
    txtSend = 'SOUR1:AMP '+ txtAmpl.get() + '\n'
    instr.write(txtSend.encode("utf-8"))

def FREQ_clicked():
    global instr
    txtSend = 'SOUR1:FREQ '+ txtFreq.get() + '\n'
    instr.write(txtSend.encode("utf-8"))

def OON_clicked():
    global instr
    txtSend = 'OUTP1 ON\n'
    instr.write(txtSend.encode("utf-8"))

def OOF_clicked():
    global instr
    txtSend = 'OUTP1 OFF\n'
    instr.write(txtSend.encode("utf-8"))

                                                 
root = tk.Tk()
root.geometry('430x320')
root.title('pySerial Sample for AWG')

label1 = tk.Label(root, text = 'COM Port:')
label1.grid(row=0, column=0,sticky = tk.E,pady=3)
txtPort = ttk.Entry(root , width=4 )
txtPort.delete(0,tk.END)
txtPort.insert(tk.END,'3')
txtPort.grid(row=0 , column=1,sticky = tk.W)

label2 = tk.Label(root, text = ' Baud :' )
label2.grid(row=0, column=2,sticky = tk.E)

cbDevBaud= ttk.Combobox(root , width=8 ,value = Baud )
cbDevBaud.set(Baud[1])
cbDevBaud.grid(row=0 , column=3)

txtRecive = tkinter.scrolledtext.ScrolledText(root , width=52, height=13 )
txtRecive.grid(row=4 , column=0, columnspan = 4 ,padx=10,pady=10)

btn1 = tk.Button(master=root, text='Open'  , command=Open_clicked ,width=8)
btn1.grid(row = 1 , column=0,pady=3 )
btn2 = tk.Button(master=root, text='Close' , command=Close_clicked , state =tk.DISABLED,width=8 )
btn2.grid(row = 1 , column=1)
btn3 = tk.Button(master=root, text='Exit'  , command=Exit_clicked,width=8)
btn3.grid(row = 1 , column=3)
btn4 = tk.Button(master=root, text='SINE'  , command=SINE_clicked, state =tk.DISABLED ,width=8)
btn4.grid(row = 3 , column=0,pady=3)
btn5 = tk.Button(master=root, text='SQU '  , command=SQU_clicked, state =tk.DISABLED ,width=8)
btn5.grid(row = 3 , column=1)
btn6 = tk.Button(master=root, text='Ampl' , command=AMPL_clicked, state =tk.DISABLED ,width=8)
btn6.grid(row = 2 , column=0,pady=3)
btn7 = tk.Button(master=root, text='Freq' , command=FREQ_clicked, state =tk.DISABLED ,width=8)
btn7.grid(row = 2 , column=2)
btn8 = tk.Button(master=root, text='OUT ON'  , command=OON_clicked, state =tk.DISABLED ,width=8)
btn8.grid(row = 3 , column=2,pady=3)
btn9 = tk.Button(master=root, text='OUT OFF' , command=OOF_clicked, state =tk.DISABLED ,width=8)
btn9.grid(row = 3 , column=3)

txtAmpl = ttk.Entry(root , width=8 )
txtAmpl.delete(0,tk.END)
txtAmpl.insert(tk.END,'3.0')
txtAmpl.grid(row=2 , column=1)
txtFreq = ttk.Entry(root , width=8 )
txtFreq.delete(0,tk.END)
txtFreq.insert(tk.END,'1.0')
txtFreq.grid(row=2 , column=3)


root.mainloop()

